#include <gtk/gtkrc.h>

typedef struct _NodokaRcStyle NodokaRcStyle;
typedef struct _NodokaRcStyleClass NodokaRcStyleClass;

G_GNUC_INTERNAL extern GType nodoka_type_rc_style;

#define NODOKA_TYPE_RC_STYLE              nodoka_type_rc_style
#define NODOKA_RC_STYLE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), NODOKA_TYPE_RC_STYLE, NodokaRcStyle))
#define NODOKA_RC_STYLE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), NODOKA_TYPE_RC_STYLE, NodokaRcStyleClass))
#define NODOKA_IS_RC_STYLE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), NODOKA_TYPE_RC_STYLE))
#define NODOKA_IS_RC_STYLE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), NODOKA_TYPE_RC_STYLE))
#define NODOKA_RC_STYLE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), NODOKA_TYPE_RC_STYLE, NodokaRcStyleClass))

typedef enum
{
	NDK_FLAG_CONTRAST = 1 << 0,
	NDK_FLAG_HILIGHT_RATIO = 1 << 1,
	NDK_FLAG_ROUNDNESS = 1 << 2,
	NDK_FLAG_MENUBARSTYLE = 1 << 3,
	NDK_FLAG_LISTVIEWHEADERSTYLE = 1 << 4,
	NDK_FLAG_LISTVIEWSTYLE = 1 << 5,
	NDK_FLAG_SCROLLBARSTYLE = 1 << 6,
	NDK_FLAG_SCROLLBAR_COLOR = 1 << 7,
	NDK_FLAG_ANIMATION = 1 << 8,
	NDK_FLAG_GRADIENTS = 1 << 9,
	NDK_FLAG_STRIPES = 1 << 10,
} NodokaRcFlags;

struct _NodokaRcStyle
{
	GtkRcStyle parent_instance;

	NodokaRcFlags flags;

	GdkColor scrollbar_color;
	gboolean has_scrollbar_color;
	double contrast;
	double hilight_ratio;
	guint8 menubarstyle;
	guint8 listviewheaderstyle;
	guint8 listviewstyle;
	guint8 scrollbarstyle;
	guint8 roundness;
	gboolean animation;
	gboolean gradients;
	gboolean stripes;
};

struct _NodokaRcStyleClass
{
	GtkRcStyleClass parent_class;
};

G_GNUC_INTERNAL void nodoka_rc_style_register_type (GTypeModule * module);
