#include <gtk/gtkstyle.h>

#include "animation.h"
#include "nodoka_types.h"

typedef struct _NodokaStyle NodokaStyle;
typedef struct _NodokaStyleClass NodokaStyleClass;

G_GNUC_INTERNAL extern GType nodoka_type_style;

#define NODOKA_TYPE_STYLE              nodoka_type_style
#define NODOKA_STYLE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), NODOKA_TYPE_STYLE, NodokaStyle))
#define NODOKA_STYLE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), NODOKA_TYPE_STYLE, NodokaStyleClass))
#define NODOKA_IS_STYLE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), NODOKA_TYPE_STYLE))
#define NODOKA_IS_STYLE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), NODOKA_TYPE_STYLE))
#define NODOKA_STYLE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), NODOKA_TYPE_STYLE, NodokaStyleClass))

struct _NodokaStyle
{
	GtkStyle parent_instance;

	NodokaColors colors;

	double hilight_ratio;

	guint8 roundness;
	guint8 progressbarstyle;
	guint8 menubarstyle;
	guint8 listviewheaderstyle;
	guint8 listviewstyle;
	guint8 scrollbarstyle;
	GdkColor scrollbar_color;
	gboolean has_scrollbar_color;
	gboolean animation;
	gboolean gradients;
	gboolean stripes;
};

struct _NodokaStyleClass
{
	GtkStyleClass parent_class;
};

G_GNUC_INTERNAL void nodoka_style_register_type (GTypeModule * module);
